package it.unibo.cs.labp.progetto2001.spec;

/**
 * E' l'intefaccia comune a tutte le espressioni del linguaggio. <p/>
 * Le classi che rappresentano una espressione devono
 * implementare i metodi per essere valutate e stampate.<br/>
 * Le classi che rappresentano una espressione costante devono implementare
 * <tt>Literal</tt> che  una interfaccia pi specifica. <p/>
 *
 * Le implementazioni che rappresentano una variabile sono tenute a
 * ridefinire il metodo <tt>public String toString()</tt> ereditato da
 * <tt>Object</tt> in modo da produrre una stringa che rappresenti il
 * valore della variabile.
 *
 * @author Riccardo Solmi
 * @version 1.0
 * @see LanguageFactory
 */

public interface Expression extends LanguageEntity {
    /**
     * Valuta l'espressione.
     *
     * @return Il risultato dell'espressione  un oggetto di tipo costante.
     * @throws IllegalArgumentException se si verifica a runtime un
     *         errore di tipo.
     * @throws IllegalStateException se si tenta di accedere ad una
     *         variabile non inizializzata.
     */
	public Literal evaluate();
}